<template>
    <div class="carousel">
      <carousel-img :src="getImageURL(currentImage(this.imageIndex).src)" :alt="currentImage(this.imageIndex).alt"></carousel-img>
      <img-changer direction='next' @click="nextImage"></img-changer>
      <img-changer direction='previous' @click="previousImage"></img-changer>
      <text-box :text="currentImage(this.imageIndex).alt"></text-box>
      <div class="selectors">
        <img-selector v-for="(item, index) in images" :key="index" :imageIndex="index" :id="isCurrentImage(index) ? 'active' : ''" @click="selectImage(index)"></img-selector>
      </div>
    </div>
</template>

<script>
import ImageCarouselChanger from './ImageCarouselChanger'
import ImageCarouselSelector from './ImageCarouselSelector'
import ImageCarouselImage from './ImageCarouselImage'
import ImageCarouselText from './ImageCarouselText'

export default {
  components: {
    'img-changer': ImageCarouselChanger,
    'img-selector': ImageCarouselSelector,
    'carousel-img': ImageCarouselImage,
    'text-box': ImageCarouselText
  },
  methods: {
    currentImage: function (imageIndex) {
      return this.images[imageIndex]
    },
    getImageURL: function (img) {
      var images = require.context('../assets/img_carousel/', false, /\.png$/)
      return images('./' + img)
    },
    nextImage: function () {
      this.imageIndex++
      if (this.imageIndex >= this.images.length) {
        this.imageIndex = 0
      }

      console.log(this.imageIndex)
    },
    previousImage: function () {
      this.imageIndex--
      if (this.imageIndex < 0) {
        this.imageIndex = this.images.length - 1
      }

      console.log(this.imageIndex)
    },
    isCurrentImage: function (index) {
      return index === this.imageIndex
    },
    selectImage: function (index) {
      this.imageIndex = index
    }
  },
  data () {
    return {
      imageIndex: 0,
      images: [
        { src: 'vanilla_automation.png', alt: 'Automate your machines in a vanilla fashion!' },
        { src: 'mechanical_power.png', alt: 'Utilize mechanical energy to power your machines!' },
        { src: 'multiblock_creations.png', alt: 'Build new structures out of different materials to create new items!' }
      ]
    }
  }
}
</script>

<style>
.carousel {
  height: 100%;
  position: relative;
  margin-bottom: 0%;
}

.selectors {
  position: absolute;
  width: 100%;
  left: 2%;
  bottom: 3%;
}
</style>
